qutil_start:                            
                lea     qutil_procs(pc),a1
                movea.w (sb.inipr).w,a2 ; INITialise PRocedure table
                jsr     (a2)
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------
qutil_procs:    dc.w $10                
                dc.w setpos-*           ; SETPOS #ch,pos
                dc.b 6,'SETPOS',0
                dc.w setup-*            ; SETUP #ch,data_space
                dc.b 5,'SETUP'
                dc.w binput-*           ; BINPUT #ch,a,b,c,...
                dc.b 6,'BINPUT',0
                dc.w winput-*
                dc.b 6,'WINPUT',0
                dc.w sinput-*           ; SINPUT #ch,len,s
                dc.b 6,'SINPUT',0
                dc.w fcopy-*            ; FCOPY #source,#dest
                dc.b 5,'FCOPY'
                dc.w bwrite-*           ; BWRITE #ch,a,b,c,...
                dc.b 6,'BWRITE',0
                dc.w wwrite-*           ; WWRITE #ch,a,b,c,...
                dc.b 6,'WWRITE',0
                dc.w lwrite-*           ; LWRITE #ch,a,b,c,...
                dc.b 6,'LWRITE',0
                dc.w swrite-*           ; SWRITE #ch,a,b,c,...
                dc.b 6,'SWRITE',0
                dc.w rechp-*            ; memory = RECHP(size)
                dc.b 5,'RECHP'
                dc.w rname-*
                dc.b 5,'RNAME'
                dc.w wname-*
                dc.b 5,'WNAME'
                dc.w tsort-*
                dc.b 5,'TSORT'
                dc.w pack_n-*
                dc.b 6,'PACK_N',0
                dc.w unpack_n-*
                dc.b 8,'UNPACK_N',0
                dc.w 0
                dc.w $A
                dc.w readsetup-*        ; data_space = READSETUP(#ch)
                dc.b 9,'READSETUP'
                dc.w pos-*              ; position = POS(#ch)
                dc.b 3,'POS'
                dc.w alchp-*            ; memory = ALCHP(size)
                dc.b 5,'ALCHP'
                dc.w findsymbol-*       ; FINDSYMBOL a,b,c
                dc.b $A
                dc.b 'FINDSYMBOL',0
                dc.w gensymbol-*
                dc.b 9,'GENSYMBOL'
                dc.w findnext-*
                dc.b 8,'FINDNEXT',0
                dc.w free-*
                dc.b 4,'FREE',0
                dc.w ra6-*              ; a6 = RA6
                dc.b 3,'RA6'
                dc.w undef-*
                dc.b 5,'UNdef'
                dc.w rmode-*            ; mode = RMODE
                dc.b 5,'RMODE'
                dc.w 0
; ---------------------------------------------------------------------------
                moveq   #0,d4           ; Return file length
                bra.s   loc_1974C

; =============== S U B R O U T I N E =======================================

; data_space = READSETUP(#ch)

readsetup:                              
                moveq   #-1,d4

loc_1974C:                              
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.s   readsetup_rts
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                subq.b  #1,d3
                bne.s   readsetup_rts
                bsr.w   ut_get_basic_chan
                bsr.s   read_header
                bne.s   readsetup_rts
                movea.l sb_buffb(a6),a2 ; long    input (etc) buffer base
                tst.b   d4
                bne.s   read_data_space
                move.l  hdr_flen(a6,a2.l),d1
                bra.w   ret_long_d1
; ---------------------------------------------------------------------------

read_data_space:                        
                move.l  hdr_data(a6,a2.l),d1 ; long	  program DATA space
                bra.w   ret_long_d1

; =============== S U B R O U T I N E =======================================

; SETUP #ch,data_space

setup:                                  
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.s   readsetup_rts
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmpi.w  #2,d3           ; Two parameters
                bne.s   readsetup_rts
                bsr.s   ut_get_basic_chan
                addq.l  #4,a1           ; Skip channel
                bsr.s   read_header
                bne.s   readsetup_rts
                move.l  (a6,a1.l),d1    ; Param2
                movea.l sb_buffb(a6),a1 ; long    input (etc) buffer base
                move.l  d1,hdr_data(a6,a1.l) ; long	  program DATA space
                move.b  #1,hdr_type(a6,a1.l) ; byte	  file TYPE
                moveq   #-1,d3
                moveq   #iof.shdr,d0    ; Set file HeaDeR
                trap    #4
                trap    #3

readsetup_rts:                          
                rts

; =============== S U B R O U T I N E =======================================


read_header:                            
                moveq   #-1,d3
                moveq   #14,d2
                move.l  a1,-(sp)
                movea.l sb_buffb(a6),a1 ; long    input (etc) buffer base
                moveq   #iof.rhdr,d0    ; Read file HeaDeR
                trap    #4
                trap    #3
                movea.l (sp)+,a1
                tst.l   d0
                rts

; =============== S U B R O U T I N E =======================================

; SETPOS #ch,pos

setpos:                                 
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.s   setpos_rts
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmpi.w  #2,d3           ; Two parameters
                bne.s   setpos_rts
                bsr.s   ut_get_basic_chan
                addq.l  #4,a1           ; Skip channel
                move.l  (a6,a1.l),d1    ; Position

loc_197D6:                              
                moveq   #-1,d3
                moveq   #iof.posa,d0    ; set file POSition to Absolute address
                trap    #3
                moveq   #0,d0

setpos_rts:                             
                rts

; =============== S U B R O U T I N E =======================================


ut_get_basic_chan:                      
                move.l  (a6,a1.l),d0
                moveq   #ch.len,d1
                mulu.w  d1,d0
                movea.l sb_chanb(a6),a2 ; long    channel table base
                adda.l  d0,a2
                movea.l (a6,a2.l),a0
                rts

; =============== S U B R O U T I N E =======================================

; position = POS(#ch)

pos:                                    
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.s   setpos_rts
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                cmpi.w  #1,d3           ; One parameter
                bne.s   setpos_rts
                bsr.s   ut_get_basic_chan
                addq.l  #4,a1           ; Remove channel from stack
                move.l  a1,-(sp)
                bsr.s   get_file_pos
                movea.l (sp)+,a1

ret_long_d1:                            
                move.l  d1,d0

ret_long_d0:                            
                move.w  #$81F,d1
                tst.l   d0
                beq.s   ret_long_0

ret_long_normalize:                     
                asl.l   #1,d0
                bvs.s   ret_long_backtrack
                subq.w  #1,d1
                bra.s   ret_long_normalize
; ---------------------------------------------------------------------------

ret_long_0:                             
                clr.w   d1
                bra.s   ret_long_put
; ---------------------------------------------------------------------------

ret_long_backtrack:                     
                roxr.l  #1,d0

ret_long_put:                           
                move.l  d0,-4(a6,a1.l)
                move.w  d1,-6(a6,a1.l)
                subq.l  #6,a1
                moveq   #2,d4
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                moveq   #0,d0
                rts

; =============== S U B R O U T I N E =======================================


get_file_pos:                           
                moveq   #0,d1
                moveq   #-1,d3
                moveq   #iof.posr,d0    ; move file POSition Relative to current position
                trap    #3
                tst.l   d0
                rts

; =============== S U B R O U T I N E =======================================

; BINPUT #ch,a,b,c,...

binput:                                 
                moveq   #1,d4           ; One byte
                bra.s   xinput
; ---------------------------------------------------------------------------
; WINPUT #ch,a,b,c,...

winput:                                 
                moveq   #2,d4           ; Two bytes

xinput:                                 
                bsr.w   ut_get_basic_chan_param ; Return channel ID in a4
                bne.s   xinput_rts

xinput_loop:                            
                cmpa.l  a3,a5
                ble.s   xinput_ok       ; No more parameters
                bsr.w   iob_fmul        ; Read d4 bytes onto arithmetic stack
                bne.s   xinput_ok
                cmpi.b  #1,d4
                bne.s   xinput_put
                moveq   #0,d0
                move.b  (a6,a1.l),d0    ; Get byte
                move.w  d0,(a6,a1.l)    ; Extend to word

xinput_put:                             
                move.b  nt_vtype(a6,a3.l),d0
                andi.b  #$F,d0
                cmpi.b  #nt.in,d0
                beq.s   xinput_put_int
                cmpi.b  #nt.fp,d0
                bne.w   ut_err_ipar
                moveq   #qa.float,d0    ; FLOAT integer
                movea.w (qa.op).w,a2    ; QL Arithmetic OPeration
                jsr     (a2)

xinput_put_int:                         
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                movea.w (sb.putp).w,a2  ; PUT Parameter
                jsr     (a2)
                addq.l  #8,a3
                bra.s   xinput_loop
; ---------------------------------------------------------------------------

xinput_ok:                              
                moveq   #0,d0

xinput_rts:                             
                rts

; =============== S U B R O U T I N E =======================================

; SINPUT #ch,len,s

sinput:                                 
                bsr.w   ut_get_basic_chan_param ; Return channel ID in a4
                bne.w   ut_err_ipar
                cmpa.l  a3,a5
                ble.w   ut_err_ipar
                move.l  a5,d5
                movea.l a3,a5
                addq.l  #8,a5
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.w   ut_err_ipar
                move.l  (a6,a1.l),d4    ; Param2
                addq.l  #8,a3
                movea.l d5,a5
                cmpa.l  a3,a5
                ble.w   ut_err_ipar
                move.b  nt_vtype(a6,a3.l),d0
                andi.b  #$F,d0
                cmpi.b  #nt.st,d0
                bne.w   ut_err_ipar
                bsr.w   iob_fmul        ; Read d4 bytes onto arithmetic stack
                bne.s   sinput_ok
                subq.l  #2,a1
                move.w  d4,(a6,a1.l)    ; Length
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                movea.w (sb.putp).w,a2  ; PUT Parameter
                jsr     (a2)

sinput_ok:                              
                moveq   #0,d0
                rts

; =============== S U B R O U T I N E =======================================

; FCOPY #source,#dest

fcopy:                                  
                bsr.w   ut_get_basic_chan_param ; Return channel ID in a4
                bne.w   ut_err_ipar
                move.l  a4,d5
                bsr.w   ut_get_basic_chan_param ; Return channel ID in a4
                bne.w   ut_err_ipar
                move.l  a4,d6

fcopy_loop:                             
                moveq   #64,d4
                movea.l d5,a4
                bsr.w   iob_fmul        ; Read d4 bytes onto arithmetic stack
                beq.s   fcopy_write
                cmpi.l  #err.eof,d0     ; End Of File
                bne.s   fcopy_rts

fcopy_write:                            
                move.l  d0,-(sp)
                move.l  d1,d2
                movea.l d6,a0
                bsr.w   iob_smul
                move.l  (sp)+,d0
                tst.l   d0
                beq.s   fcopy_loop
                moveq   #0,d0

fcopy_rts:                              
                rts

; =============== S U B R O U T I N E =======================================

; BWRITE #ch,a,b,c,...

bwrite:                                 
                moveq   #1,d5           ; One byte
                bra.s   xwrite

; =============== S U B R O U T I N E =======================================

; WWRITE #ch,a,b,c,...

wwrite:                                 
                moveq   #2,d5           ; Two bytes
                bra.s   xwrite

; =============== S U B R O U T I N E =======================================

; LWRITE #ch,a,b,c,...

lwrite:                                 
                moveq   #4,d5           ; Four bytes
                bra.s   xwrite

; =============== S U B R O U T I N E =======================================

; SWRITE #ch,a,b,c,...

swrite:                                 
                moveq   #0,d5           ; String

xwrite:                                 
                bsr.s   ut_get_basic_chan_param ; Return channel ID in a4
                bne.s   ut_err_ipar

xwrite_loop:                            
                moveq   #2,d1
                bsr.w   qa_resri
                cmpa.l  a3,a5
                ble.s   xwrite_ok
                move.l  a5,d4
                movea.l a3,a5
                addq.l  #8,a5
                tst.l   d5
                bne.s   xwrite_bwl
                movea.w (sb.gtstr).w,a2 ; Write string
                jsr     (a2)
                clr.l   d2
                move.w  (a6,a1.l),d2    ; String size
                addq.l  #2,a1           ; Skip size
                bra.s   xwrite_do
; ---------------------------------------------------------------------------

xwrite_bwl:                             
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.s   ut_err_ipar
                addq.l  #4,a1
                move.l  d5,d2
                suba.l  d2,a1

xwrite_do:                              
                movea.l d4,a5
                addq.l  #8,a3
                movea.l a4,a0
                bsr.s   iob_smul
                beq.s   xwrite_loop
                rts
; ---------------------------------------------------------------------------

xwrite_ok:                              
                moveq   #0,d0
                rts

; =============== S U B R O U T I N E =======================================

; Return channel ID in a4

ut_get_basic_chan_param:                
                cmpa.l  a3,a5
                ble.s   ut_err_ipar
                btst    #nt..hash,nt_vtype(a6,a3.l) ; preceded by hash
                beq.s   ut_err_ipar
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                move.l  a5,-(sp)
                movea.l a3,a5
                addq.l  #8,a5           ; Only get the first parameter
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                movea.l (sp)+,a5
                bne.s   ut_err_ipar
                addq.l  #8,a3           ; Remove parameter from stack
                bsr.w   ut_get_basic_chan
                movea.l a0,a4
                moveq   #0,d0
                tst.l   d0
                rts

; =============== S U B R O U T I N E =======================================


iob_smul:                               
                moveq   #-1,d3
                moveq   #iob.smul,d0    ; Send MULtiple bytes
                trap    #4
                trap    #3
                tst.l   d0
                rts
; ---------------------------------------------------------------------------
ut_err_ipar:                            
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                tst.l   d0
                rts

; =============== S U B R O U T I N E =======================================

; Read d4 bytes onto arithmetic stack

iob_fmul:                               
                move.l  d4,d1
                bsr.s   qa_resri
                movea.l a4,a0
                move.w  d4,d2
                moveq   #-1,d3
                moveq   #iob.fmul,d0    ; Fetch MULtiple characters/bytes
                trap    #4
                trap    #3
                suba.l  d1,a1
                tst.l   d0
                rts

; =============== S U B R O U T I N E =======================================


qa_resri:                               
                move.l  d1,-(sp)
                addq.l  #1,d1
                movea.w (qa.resri).w,a2 ; REServe RI stack
                jsr     (a2)
                move.l  (sp)+,d1
                move.l  sb_arthp(a6),d0 ; long    arithmetic stack pointer
                sub.l   d1,d0
                btst    #0,d0
                beq.s   qa_resri_rts
                subq.l  #1,d0

qa_resri_rts:                           
                movea.l d0,a1
                rts

; =============== S U B R O U T I N E =======================================

; memory = ALCHP(size)

alchp:                                  
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                cmpi.w  #1,d3
                bne.w   ut_err_ipar
                move.l  (a6,a1.l),d1
                moveq   #-1,d2
                moveq   #sms.achp,d0    ; Allocate space in Common HeaP
                trap    #1
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                addq.l  #4,a1
                move.l  a0,d1
                tst.l   d0
                beq.w   ret_long_d1
                moveq   #0,d0
                bra.w   ret_long_d0

; =============== S U B R O U T I N E =======================================

; memory = RECHP(size)

rechp:                                  
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                cmpi.w  #1,d3
                bne.w   ut_err_ipar
                movea.l (a6,a1.l),a0
                moveq   #sms.rchp,d0    ; Release space in Common HeaP
                trap    #1
                moveq   #0,d0
                rts

; =============== S U B R O U T I N E =======================================

; bytes = FREE

free:                                   
                moveq   #0,d0
                trap    #1
                move.l  sys_sbab(a0),d0 ; 'QL SuperBASIC' Area Base
                sub.l   sys_fsbb(a0),d0 ; Filing system Slave Block area Base
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                bra.w   ret_long_d0

; =============== S U B R O U T I N E =======================================

; FINDSYMBOL a,b,c

findsymbol:                             
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                cmpi.w  #3,d3           ; Three parameters
                bne.w   ut_err_ipar
                movea.l (a6,a1.l),a5    ; Param1
                move.l  4(a6,a1.l),d2   ; Param2
                bsr.w   symbol_lookup   ; a5 = address
                beq.s   loc_19A7E
                neg.l   d2
                movea.l (a6,a1.l),a5
                bsr.w   symbol_lookup   ; a5 = address
                bne.s   loc_19A8C
                move.l  8(a6,a1.l),2(a3)
                bra.s   loc_19A82
; ---------------------------------------------------------------------------

loc_19A7E:                              
                sub.l   8(a6,a1.l),d1

loc_19A82:                              
                move.l  d1,d0

loc_19A84:                              
                lea     $C(a1),a1
                bra.w   ret_long_d0
; ---------------------------------------------------------------------------

loc_19A8C:                              
                cmpa.l  4(a5),a2
                beq.s   loc_19AA0
                move.w  d2,(a2)+
                move.l  8(a6,a1.l),(a2)+
                move.l  a2,8(a5)
                moveq   #0,d0
                bra.s   loc_19A84
; ---------------------------------------------------------------------------

loc_19AA0:                              
                moveq   #1,d0
                movea.l $58(a6),a1
                lea     $A(a1),a1
                bra.s   xsym_ret_int

; =============== S U B R O U T I N E =======================================

; GENSYMBOL #ch,block,b,c
;
; Block offsets:
;
; 0 - Next block
; 4 - Max entry
; 8 - Last entry
; 12 - 6 byte entries

gensymbol:                              
                bsr.w   ut_get_basic_chan_param ; Return channel ID in a4
                bne.w   ut_err_ipar
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                cmpi.w  #3,d3           ; Three additional parameters
                bne.w   ut_err_ipar
                movea.l (a6,a1.l),a5    ; Param1
                move.l  4(a6,a1.l),d2   ; Param2
                neg.l   d2
                bsr.w   symbol_lookup   ; a5 = address
                beq.s   gsym_found
                cmpa.l  sb_block_end(a5),a2
                beq.s   gsym_block_full
                neg.l   d2
                move.w  d2,(a2)+
                move.l  8(a6,a1.l),(a2)+ ; Param3
                move.l  a2,sb_last_entry(a5)

gsym_ok:                                
                moveq   #0,d0
                bra.s   gsym_remove_params
; ---------------------------------------------------------------------------

gsym_block_full:                        
                moveq   #err.nc,d0      ; operation Not Complete

gsym_remove_params:                     
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                lea     4*4-2(a1),a1    ; Remove parameters from stack and leave space for an int

xsym_ret_int:                           
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                move.w  d0,(a6,a1.l)
                moveq   #nt.in,d4
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

gsym_found:                             
                neg.l   d2
                move.w  d2,(a3)+
                move.l  (a3),d4
                move.l  8(a6,a1.l),(a3)
                movea.l a1,a5
                bsr.w   get_file_pos
                move.l  d1,d5

loc_19B12:                              
                tst.l   d4
                beq.s   loc_19B52
                move.l  d4,d1
                bsr.w   loc_197D6
                movea.l (a6),a1
                moveq   #4,d2
                moveq   #-1,d3
                movea.l a4,a0
                moveq   #iob.fmul,d0    ; Fetch MULtiple characters/bytes
                trap    #4
                trap    #3
                tst.l   d0
                bne.s   gsym_remove_params
                move.l  d4,d1
                bsr.w   loc_197D6
                moveq   #4,d2
                movea.l (a6),a1
                move.l  8(a6,a5.l),d0
                sub.l   d4,d0
                move.l  (a6,a1.l),d4
                move.l  d0,(a6,a1.l)
                moveq   #iob.smul,d0    ; Send MULtiple bytes
                trap    #4
                trap    #3
                tst.l   d0
                beq.s   loc_19B12
                rts
; ---------------------------------------------------------------------------

loc_19B52:                              
                move.l  d5,d1
                bsr.w   loc_197D6
                bra.s   gsym_ok
; ---------------------------------------------------------------------------
symbol_lookup_next_block:               
                movea.l (a5),a5

; =============== S U B R O U T I N E =======================================

; a5 = address

symbol_lookup:                          
                movea.l a5,a3
                addq.l  #8,a3
                movea.l (a3)+,a2

symbol_lookup_loop:                     
                cmpa.l  a3,a2
                ble.s   symbol_lookup_block_end
                cmp.w   (a3),d2
                beq.s   symbol_lookup_found
                addq.l  #6,a3
                bra.s   symbol_lookup_loop
; ---------------------------------------------------------------------------

symbol_lookup_found:                    
                moveq   #0,d1
                move.l  2(a3),d1
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

symbol_lookup_block_end:                
                cmpi.l  #0,sb_next_block(a5)
                bne.s   symbol_lookup_next_block
                moveq   #1,d0
                rts

; =============== S U B R O U T I N E =======================================


findnext:                               
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                cmpi.w  #2,d3           ; Two parameters
                bne.w   ut_err_ipar
                movea.l (a6,a1.l),a5
                move.l  4(a6,a1.l),d2
                lea     8(a1),a1
                bsr.s   findnext_lookup
                bne.s   loc_19BA8
                move.w  (a3),d0
                bra.w   ret_long_d0
; ---------------------------------------------------------------------------

loc_19BA8:                              
                moveq   #err.nc,d0      ; operation Not Complete
                subq.l  #2,a1
                bra.w   xsym_ret_int
; ---------------------------------------------------------------------------
findnext_lookup_next_block:             
                movea.l (a5),a5

; =============== S U B R O U T I N E =======================================


findnext_lookup:                        
                movea.l a5,a3
                addq.l  #8,a3
                movea.l (a3)+,a2
                moveq   #0,d0

findnext_lookup_loop:                   
                cmpa.l  a3,a2
                ble.s   findnext_lookup_block_end
                tst.w   d2
                bmi.s   loc_19BCA
                cmp.w   (a3),d2
                ble.s   symbol_lookup_found
                addq.l  #6,a3
                bra.s   findnext_lookup_loop
; ---------------------------------------------------------------------------

loc_19BCA:                              
                move.w  (a3),d0
                cmp.l   d0,d2
                ble.s   symbol_lookup_found
                addq.l  #6,a3
                bra.s   findnext_lookup_loop
; ---------------------------------------------------------------------------

findnext_lookup_block_end:              
                cmpi.l  #0,(a5)
                bne.s   findnext_lookup_next_block
                moveq   #1,d0
                rts

; =============== S U B R O U T I N E =======================================

; TSORT symbols-block
;
; Bubble sort of symbols table

tsort:                                  
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                bne.s   tsort_rts

tsort_again:                            
                movea.l (a6,a1.l),a5    ; Param1
                addq.l  #sb_last_entry,a5
                movea.l (a5)+,a4        ; a4 = last entry
                movea.l a5,a3           ; a3 = start of entries
                moveq   #0,d2           ; No change done yet
                movea.l a3,a2           ; a2 = start of entries

tsort_advance:                          
                addq.l  #sb.entry_size,a3
                cmpa.l  a3,a4           ; Past last entry?
                ble.s   tsort_done

tsort_next_block:                       
                moveq   #0,d0
                moveq   #0,d1
                move.w  (a3),d0
                move.w  (a2),d1
                cmp.l   d1,d0
                bgt.s   tsort_sorted
                move.w  d0,(a2)         ; Exchange entries in a2 and a3
                move.w  d1,(a3)
                move.l  2(a2),d1
                move.l  2(a3),2(a2)
                move.l  d1,2(a3)
                moveq   #1,d2           ; Changed something!

tsort_sorted:                           
                movea.l a3,a2
                bra.s   tsort_advance
; ---------------------------------------------------------------------------

tsort_done:                             
                move.l  -sb_entries(a5),d0 ; sb_next_block
                beq.s   tsort_no_next_block
                movea.l d0,a5
                addq.l  #sb_last_entry,a5
                movea.l (a5)+,a4
                movea.l a5,a3
                bra.s   tsort_next_block
; ---------------------------------------------------------------------------

tsort_no_next_block:                    
                tst.l   d2
                bne.s   tsort_again     ; We changed something, go through the blocks again
                moveq   #0,d0

tsort_rts:                              
                rts

; =============== S U B R O U T I N E =======================================

; RNAME addr,var1,var2,...
;
; Put up to 46 bytes from addr into the variables

rname:                                  
                bsr.s   ut_get_long1
                bne.s   xname_ipar
                movea.l (a6,a1.l),a4    ; Data block
                moveq   #50,d1
                bsr.w   qa_resri
                move.l  a1,sb_arthp(a6) ; long    arithmetic stack pointer
                moveq   #22,d4          ; (22+1)*2 = 46 bytes

rname_copy_loop:                        
                move.w  (a4)+,(a6,a1.l)
                addq.l  #2,a1
                dbf     d4,rname_copy_loop
                moveq   #nt.in,d4

rname_put_loop:                         
                cmpa.l  a3,a5
                ble.s   rname_ok
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                movea.w (sb.putp).w,a2  ; PUT Parameter
                jsr     (a2)
                addq.l  #8,a3
                dbne    d4,rname_put_loop

rname_ok:                               
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

xname_ipar:                             
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                rts

; =============== S U B R O U T I N E =======================================


ut_get_long1:                           
                move.l  a5,d4           ; Save a5
                movea.l a3,a5
                addq.l  #8,a5
                movea.w (sb.gtlin).w,a2 ; GeT Long INteger
                jsr     (a2)
                movea.l d4,a5
                addq.l  #8,a3
                subq.w  #1,d3
                rts

; =============== S U B R O U T I N E =======================================

; WNAME addr,i1,i2,i3,str
;
; Append i1, i2, i3 and characters of str into addr data block

wname:                                  
                bsr.s   ut_get_long1
                bne.s   xname_ipar
                movea.l (a6,a1.l),a4    ; Data block
                moveq   #2,d4           ; 3 loops
                move.l  a5,d5

wname_loop:                             
                cmp.l   a3,d5
                ble.s   wname_rts
                movea.l a3,a5
                addq.l  #8,a5
                movea.w (sb.gtint).w,a2 ; GeT INTeger
                jsr     (a2)
                bne.s   wname_rts
                addq.l  #nt.len,a3
                move.w  (a6,a1.l),(a4)+ ; Copy 6 bytes into data block
                dbf     d4,wname_loop
                cmp.l   a3,d5
                ble.s   wname_rts
                movea.l a3,a5
                addq.l  #nt.len,a5
                movea.w (sb.gtstr).w,a2 ; GeT STRing
                jsr     (a2)
                bne.s   wname_rts
                move.w  (a6,a1.l),d0    ; String length
                addq.w  #1,d0
                lsr.l   #1,d0           ; Round up

wname_char_loop:                        
                move.w  (a6,a1.l),(a4)+ ; Append string
                addq.l  #2,a1
                dbf     d0,wname_char_loop

wname_rts:                              
                moveq   #0,d0
                rts

; =============== S U B R O U T I N E =======================================

; mode = RMODE

rmode:                                  
                moveq   #-1,d1
                move.l  d1,d2
                moveq   #sms.dmod,d0    ; set the Display MODe
                trap    #1
                moveq   #4,d2
                cmpi.b  #0,d1
                beq.s   rmode_exit
                moveq   #8,d2

rmode_exit:                             
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                move.w  d2,(a6,a1.l)
                moveq   #nt.in,d4
                rts

; =============== S U B R O U T I N E =======================================

; a6 = RA6

ra6:                                    
                move.l  a6,d0
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                bra.w   ret_long_d0

; =============== S U B R O U T I N E =======================================


undef:                                  
                cmpa.l  a3,a5
                beq.s   undef_ipar
                movea.l sb_arthp(a6),a1 ; long    arithmetic stack pointer
                moveq   #nt.st,d1
                move.b  nt_nvalp(a6,a3.l),d0
                beq.s   undef_set       ; nt.unset?
                moveq   #-1,d0
                cmp.l   nt_value(a6,a3.l),d0
                beq.s   undef_set
                moveq   #nt.ss,d1

undef_set:                              
                move.w  d1,nt_usetp(a6,a1.l)
                moveq   #nt.in,d4
                moveq   #0,d0
                rts
; ---------------------------------------------------------------------------

undef_ipar:                             
                moveq   #err.ipar,d0    ; Invalid PARameter (c.f. err.orng)
                rts

; =============== S U B R O U T I N E =======================================

; UNPACK_N v,n1,n2,b1,b2,b3,b4,b5,b6,b7
;
; Unpack v into parameters:
;
; 14 13 12 11 10 09 08 07 06 05 04 03 02 01 00
; b7 b6 b5 b4 b3 b2 b1 n2 n2 n2 n2 n1 n1 n1 n1

unpack_n:                               
                movea.l nt_value(a6,a3.l),a0
                adda.l  sb_datab(a6),a0 ; long    data area base (first block)
                move.w  (a6,a0.l),d0    ; INT to unpack
                moveq   #1,d2

unpack_n_nibble:                        
                addq.l  #nt.len,a3
                movea.l nt_value(a6,a3.l),a0
                adda.l  sb_datab(a6),a0 ; long    data area base (first block)
                move.w  d0,d1
                andi.w  #%1111,d1
                move.w  d1,(a6,a0.l)    ; Save in variable
                lsr.w   #4,d0
                dbf     d2,unpack_n_nibble
                moveq   #6,d2

unpack_n_bits:                          
                addq.l  #8,a3
                movea.l 4(a6,a3.l),a0
                adda.l  sb_datab(a6),a0 ; long    data area base (first block)
                move.w  d0,d1
                andi.w  #1,d1
                move.w  d1,(a6,a0.l)
                lsr.w   #1,d0
                dbf     d2,unpack_n_bits
                moveq   #0,d0
                rts

; =============== S U B R O U T I N E =======================================

; PACK_N v,n1,n2,b1,b2,b3,b4,b5,b6,b7
;
; Pack parameters into v:
;
; 14 13 12 11 10 09 08 07 06 05 04 03 02 01 00
; b7 b6 b5 b4 b3 b2 b1 n2 n2 n2 n2 n1 n1 n1 n1

pack_n:                                 
                moveq   #0,d0
                moveq   #6,d2

pack_n_bits:                            
                subq.l  #nt.len,a5
                movea.l nt_value(a6,a5.l),a0
                adda.l  sb_datab(a6),a0 ; long    data area base (first block)
                move.w  (a6,a0.l),d1    ; Expect INT here
                andi.w  #1,d1           ; Only LSB
                lsl.w   #1,d0           ; Integrate it into result
                or.w    d1,d0
                dbf     d2,pack_n_bits
                moveq   #1,d2

pack_n_nibble:                          
                subq.l  #nt.len,a5
                movea.l nt_value(a6,a5.l),a0
                adda.l  sb_datab(a6),a0 ; long    data area base (first block)
                move.w  (a6,a0.l),d1
                andi.w  #%1111,d1
                lsl.w   #4,d0
                or.w    d1,d0
                dbf     d2,pack_n_nibble
                movea.l nt_value(a6,a3.l),a0
                adda.l  sb_datab(a6),a0 ; long    data area base (first block)
                move.w  d0,(a6,a0.l)
                moveq   #0,d0
                rts
                
		end